#import "OxSaiFlutterSdkPlugin.h"
#if __has_include(<ox_sai_flutter_sdk/ox_sai_flutter_sdk-Swift.h>)
#import <ox_sai_flutter_sdk/ox_sai_flutter_sdk-Swift.h>
#else
// Support project import fallback if the generated compatibility header
// is not copied when this plugin is created as a library.
// https://forums.swift.org/t/swift-static-libraries-dont-copy-generated-objective-c-header/19816
#import "ox_sai_flutter_sdk-Swift.h"

#endif

#define TEST_ISIPHONEX \
({BOOL isPhoneX = NO;\
if ([UIDevice currentDevice].systemVersion.floatValue >= 11.0) {\
isPhoneX = [[UIApplication sharedApplication] delegate].window.safeAreaInsets.bottom > 0.0;\
}\
(isPhoneX);})
#define NavHeight (TEST_ISIPHONEX ? 88 : 64)
#define TEST_HEXCOLOR(hex) [UIColor colorWithRed:((float)((hex & 0xFF0000) >> 16)) / 255.0 green:((float)((hex & 0xFF00) >> 8)) / 255.0 blue:((float)(hex & 0xFF)) / 255.0 alpha:1]
#define getRectNavAndStatusHight  (self.navigationController.navigationBar.frame.size.height+[[UIApplication sharedApplication] statusBarFrame].size.height)
#define TEST_SCREEN_WIDTH   [UIScreen mainScreen].bounds.size.width
#define TEST_SCREENH_HEIGHT [UIScreen mainScreen].bounds.size.height
#define TEST_SCREEN_WIDTH_RATIO TEST_SCREEN_WIDTH/375
#define TEST_SCREENH_HEIGHT_RATIO TEST_SCREENH_HEIGHT/667

#define FullModelShouldAutorotate YES
#define WindowBottomModelShouldAutorotate NO

#define OXVerifyNotification @"OXVerifyNotification"

#import <OXSaiSDK/OXSaiSDK.h>
#import <YYImage/YYImage.h>
#import <ReactiveObjC/RACEXTScope.h>
#import <Masonry/Masonry.h>
#import "View/OXTestShowToastView.h"
@interface OxSaiFlutterSdkPlugin()<OXActionDelegate>
@property (nonatomic,strong)FlutterResult result;
@end

@implementation OxSaiFlutterSdkPlugin

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    FlutterMethodChannel *channel = [FlutterMethodChannel
               methodChannelWithName:@"ox_sai_flutter_sdk"
                     binaryMessenger:[registrar messenger]];
    OxSaiFlutterSdkPlugin *instance = [[OxSaiFlutterSdkPlugin alloc] init];
    [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall *)call result:(FlutterResult)result {
    NSLog(@"🐷%@:%@",call.method,call.arguments);
    self.result = result;
    if ([@"getSdkVersion" isEqualToString:call.method]) {
        
        result([OXClientEntry sdkVersion]);
        
    }else if ([@"oxInitSaiSDK" isEqualToString:call.method]){
        
        NSString *appid = [call.arguments valueForKey:@"appid"];
        NSString *appsecret = [call.arguments valueForKey:@"appsecret"];
        [self initSAIWithAppid:appid appserect:appsecret];
        
    }else if ([@"oxOnekeyLogin" isEqualToString:call.method]){
        
        [OXClientEntry oneKeyCustomUIWithParams:[self portraitModel]];//弹框范例--范例支持横竖屏切换
        UIViewController *vc = [self appRootViewController];
        [OXClientEntry requestAction:OXActionTypeGetOnekeyLoginToken params:@{OXCurrentVC:vc,@"timeout":@"5"}];
        
    }else if ([@"oxAuthMobilePhone" isEqualToString:call.method]){
        
        [OXClientEntry requestAction:OXActionTypeGetMobileAuthToken params:nil];
        
    }else if ([@"oxPreLogin" isEqualToString:call.method]){
        
        [OXClientEntry requestAction:OXActionTypePreLogin params:nil];
        
    }else {
        result(FlutterMethodNotImplemented);
    }
}
#pragma mark - 回调
/**
 SDK初始化回调
 @param response 返回的response
 如果respose.code为00000代表成功
 */
-(void)oxActionInitSdkResponse:(NSDictionary *)response{
    self.result(response);
}

/**
 功能服务回调

 @param result 回调结果
 */
-(void)onActionResult:(NSDictionary *)result{
    NSString *code = [NSString stringWithFormat:@"%@",result[@"result"][@"code"]];
    NSInteger action_type = [[result valueForKey:@"action_type"] integerValue];
    switch (action_type) {
        case OXActionTypeGetOnekeyLoginToken:
            if(![code isEqualToString:@"45033"]){
                self.result(result);
            }
            break;
        case OXActionTypeGetMobileAuthToken:
                self.result(result);
            break;
        case OXActionTypePreLogin:
                self.result(result);
            break;
        default:
            break;
    }
}


#pragma mark 全屏model

-(OXOneKeyCustomModel *)portraitModel{
    OXOneKeyCustomModel *model = [[OXOneKeyCustomModel alloc] init];
    model.oxNavigationBackBtnImage = [UIImage imageNamed:@"close"];
    model.oxAppTermsWebBackBtnImage = [UIImage imageNamed:@"close"];
    model.oxNavigationBarStyle = @(UIBarStyleBlack);
    model.oxAppTermsWebNavigationBarStyle =@(UIBarStyleDefault);
    model.oxShouldAutorotate = @(FullModelShouldAutorotate);
    model.oxSupportedInterfaceOrientations = @(UIInterfaceOrientationMaskAll);
    model.oxShouldAutorotate = @(NO);
    model.oxNavigationBackgroundoxear = @(YES);
    model.oxLogoHiden = @(YES);
//    model.manualDismiss = @(YES);
//    model.oxAppTermsPageWindow = @(YES);
    model.oxPhoneNumberColor = [UIColor blackColor];
    model.oxPhoneNumberFont = [UIFont systemFontOfSize:35];
    model.oxLoginBtnText = @"本机号码一键登录";
    model.oxLoginBtnTextColor = TEST_HEXCOLOR(0xffffff) ;
    model.oxLoginBtnBgColor = TEST_HEXCOLOR(0x3D7EFF);
    model.oxLoginBtnTextFont = [UIFont systemFontOfSize:19];
    model.oxLoginBtnCornerRadius = @(0);
    model.oxSloganTextFont = [UIFont systemFontOfSize:12];
    model.oxSloganTextColor = [UIColor grayColor];
    model.oxAppTermsColor = @[TEST_HEXCOLOR(0x3D7EFF),[UIColor grayColor]];
    model.oxAppTermsLineSpacing = @(5);
//    model.oxTermsTemplate = [[NSAttributedString alloc]initWithString:@"登录即同意&&默认&&和《自定义条款一》、《自定义条款二》并使用本机号码登录" attributes:@{NSFontAttributeName:[UIFont systemFontOfSize:12] ,NSForegroundColorAttributeName:[UIColor lightGrayColor]}];
//    NSAttributedString *str1 = [[NSAttributedString alloc]initWithString:@"《自定义条款一》" attributes:@{NSLinkAttributeName:@"https://www.baidu.com"}];
//    NSAttributedString *str2 = [[NSAttributedString alloc]initWithString:@"《自定义条款二》" attributes:@{NSLinkAttributeName:@"https://www.qq.com"}];
//    model.oxTerms = @[str1,str2];
//    model.oxAppTermsPunctuationMarks = @(YES);
//    model.oxAppTermsEdgeInsets = [NSValue valueWithUIEdgeInsets:UIEdgeInsetsMake(5, 5, 5, 5)];
//    model.oxCheckBoxHidden= @(YES);
    model.oxCheckBoxValue= @(YES);
//    model.oxCheckBoxSize = [NSValue valueWithCGSize:CGSizeMake(5, 5)];
//     __weak typeof(self) weakSelf = self;
//     @weakify(model)
//    model.customAreaView = ^(UIView * _Nonnull customAreaView) {
//        __strong typeof(weakSelf) strongSelf = weakSelf;
//        customAreaView.backgroundColor = [UIColor blackColor];
//        UIImageView *backGroundImg = [[YYAnimatedImageView alloc] init];
//        backGroundImg.image =  [YYImage imageNamed:@"2019_P.gif"];
//        [customAreaView addSubview:backGroundImg];
//
//        UIButton * threeLogin= [[UIButton alloc] init];
//        threeLogin.center = CGPointMake(TEST_SCREEN_WIDTH/2, threeLogin.center.y);
//        [threeLogin setTitle:@"其它方式登录" forState:UIControlStateNormal];
//        threeLogin.backgroundColor = [[UIColor whiteColor] colorWithAlphaComponent:0.3];
//        [threeLogin addTarget:self action:@selector(threeLoginClick) forControlEvents:UIControlEventTouchUpInside];
//        [customAreaView addSubview:threeLogin];
//
//        UIButton *help = [[UIButton alloc] init];
//        help.titleLabel.font = [UIFont systemFontOfSize:12];
//        [help setTitleColor:TEST_HEXCOLOR(0xEEC900) forState:UIControlStateNormal];
//        [help setTitle:@"登录遇到问题" forState: UIControlStateNormal];
//        [help addTarget:self action:@selector(helpBtnClick) forControlEvents:UIControlEventTouchUpInside];
//        help.backgroundColor = [UIColor clearColor];
//        [customAreaView addSubview:help];
//        @strongify(model)
//        [strongSelf screenRotationEventWithBgImage:backGroundImg threeloginBtn:threeLogin helpBtn:help customView:customAreaView model:model];
//        @weakify(backGroundImg)
//        @weakify(threeLogin)
//        @weakify(help)
//        @weakify(customAreaView)
//        @weakify(model)
//         if (FullModelShouldAutorotate) {
//            [[NSNotificationCenter defaultCenter] addObserverForName:UIApplicationDidChangeStatusBarFrameNotification object:nil queue:NSOperationQueue.mainQueue usingBlock:^(NSNotification * _Nonnull note) {
//                @strongify(backGroundImg)
//                @strongify(threeLogin)
//                @strongify(help)
//                @strongify(customAreaView)
//                @strongify(model)
//                [weakSelf screenRotationEventWithBgImage:backGroundImg threeloginBtn:threeLogin helpBtn:help customView:customAreaView model:model];
//            }];
//         }
//    };
//    model.loadingView = ^(UIView * _Nonnull containerView) {
//        UIImage *image = [YYImage imageNamed:@"loading.gif"];
//        UIImageView *imageBackground = [[YYAnimatedImageView alloc] initWithImage:image];
//        [containerView addSubview:imageBackground];
//        imageBackground.frame = CGRectMake(0, 0, 80, 80);
//        imageBackground.center = containerView.center;
//        imageBackground.layer.cornerRadius = 40;
//        imageBackground.layer.masksToBounds = YES;
//    };
//    model.webLoadingView = ^(UIView * _Nonnull containerView) {
//        UIImage *image = [YYImage imageNamed:@"loading.gif"];
//        UIImageView *imageBackground = [[YYAnimatedImageView alloc] initWithImage:image];
//        [containerView addSubview:imageBackground];
//        imageBackground.frame = CGRectMake(0, 0, 80, 80);
//        imageBackground.center = containerView.center;
//        imageBackground.layer.cornerRadius = 40;
//        imageBackground.layer.masksToBounds = YES;
//    };
//    model.toastView = ^(UIView * _Nonnull containerView) {
//        [OXTestShowToastView showToastView:containerView WithMessage:@"你还没勾选协议呢"];
//    };
//竖屏
    model.oxOrientationLayOutPortrait = [self setLayoutPortrait];
//横屏
    model.oxOrientationLayOutLandscape = [self setLayoutLandscape];
    return model;
}

/**屏幕横竖屏切换customView自定义试图适配*/

-(void)screenRotationEventWithBgImage:(UIImageView *)bgImage threeloginBtn:(UIButton*)threeloginBtn helpBtn:(UIButton *)helpBtn customView:(UIView *)customView model:(OXOneKeyCustomModel *)model{
    CGFloat screenWidth_Portrait;
    CGFloat screenHeight_Portrait;
    UIInterfaceOrientation orientation = [UIApplication sharedApplication].statusBarOrientation;
    if (orientation == UIInterfaceOrientationPortrait || orientation == UIInterfaceOrientationPortraitUpsideDown) {
        screenWidth_Portrait = UIScreen.mainScreen.bounds.size.width;
        screenHeight_Portrait = UIScreen.mainScreen.bounds.size.height;
    }else{
        screenWidth_Portrait = UIScreen.mainScreen.bounds.size.height;
        screenHeight_Portrait = UIScreen.mainScreen.bounds.size.width;
        
    }
    if (orientation == UIInterfaceOrientationPortrait || orientation == UIInterfaceOrientationPortraitUpsideDown) {
//        NSLog(@"🐷%f",screenWidth_Portrait);
        if (screenWidth_Portrait) {
            //竖屏
            [bgImage mas_remakeConstraints:^(MASConstraintMaker *make) {
                make.top.mas_equalTo(0);
                make.left.mas_equalTo(0);
                make.size.mas_equalTo(CGSizeMake(screenWidth_Portrait, screenHeight_Portrait));
            }];
            
            [threeloginBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
                make.left.mas_equalTo(screenWidth_Portrait/2-screenWidth_Portrait/375*310/2);
                make.top.mas_equalTo(screenWidth_Portrait/375*180+10+45+10+NavHeight);
                make.size.mas_equalTo(CGSizeMake(screenWidth_Portrait/375*310, 45));
            }];
            [helpBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
                make.left.mas_equalTo(0);
                make.top.mas_equalTo(screenWidth_Portrait/375*190+10+45+45+10+NavHeight+model.oxAppTermsHeight+10);
                make.size.mas_equalTo(CGSizeMake(screenWidth_Portrait, 20));
    //            make.bottom.mas_equalTo(-20-(TEST_ISIPHONEX?16:0));
            }];
        }

        bgImage.image =  [YYImage imageNamed:@"2019_P.gif"];
    }else{
        [bgImage mas_remakeConstraints:^(MASConstraintMaker *make) {
             make.top.mas_equalTo(0);
             make.left.mas_equalTo(0);
             make.size.mas_equalTo(CGSizeMake(screenHeight_Portrait, screenWidth_Portrait));
        }];
        [threeloginBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.mas_equalTo(screenHeight_Portrait/2-300/2);
            make.top.mas_equalTo(screenWidth_Portrait/375*30+40+20+45+5+5+10+44);
            make.size.mas_equalTo(CGSizeMake(300, 45));
        }];
        [helpBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.mas_equalTo(0);
            make.top.mas_equalTo(screenWidth_Portrait/375*30+40+20+45+45+5+5+5+10+44+model.oxAppTermsHeight+5);
            make.size.mas_equalTo(CGSizeMake(screenHeight_Portrait, 20));
//            make.bottom.mas_equalTo(-15-(TEST_ISIPHONEX?16:0));
        }];
        bgImage.image = [UIImage imageNamed:@"2019_L.jpeg"];
        
    }
}
#pragma mark 全屏Layout
//竖屏
-(OXOrientationLayOut *)setLayoutPortrait{
    CGFloat ratio;
    if (TEST_SCREEN_WIDTH>TEST_SCREENH_HEIGHT) {
        ratio = TEST_SCREENH_HEIGHT/375;
    }else{
        ratio = TEST_SCREEN_WIDTH/375;
    }
    OXOrientationLayOut *oxOrientationLayOutPortrait = [OXOrientationLayOut new];
    /**LOGO图片*/
    //    oxOrientationLayOutPortrait.oxLayoutLogoLeft = @(70);
//    oxOrientationLayOutPortrait.oxLayoutLogoTop = @(60);
    //    oxOrientationLayOutPortrait.oxLayoutLogoRight = @(70);
    //    oxOrientationLayOutPortrait.oxLayoutLogoBottom = @(70);
//    oxOrientationLayOutPortrait.oxLayoutLogoWidth = @(80);
//    oxOrientationLayOutPortrait.oxLayoutLogoHeight = @(80);
//    oxOrientationLayOutPortrait.oxLayoutLogoCenterX = @(0);
    //    oxOrientationLayOutPortrait.oxLayoutLogoCenterY = @(0);
    /**手机号显示控件*/
    //    oxOrientationLayOutPortrait.oxLayoutPhoneLeft = @(70);
    oxOrientationLayOutPortrait.oxLayoutPhoneTop = @(ratio*120);
    //    oxOrientationLayOutPortrait.oxLayoutPhoneRight = @(70);
    //    oxOrientationLayOutPortrait.oxLayoutPhoneBottom = @(70);
    oxOrientationLayOutPortrait.oxLayoutPhoneWidth = @(200);
    oxOrientationLayOutPortrait.oxLayoutPhoneHeight = @(40);
    oxOrientationLayOutPortrait.oxLayoutPhoneCenterX = @(0);
    //    oxOrientationLayOutPortrait.oxLayoutPhoneCenterY = @(70);
    
    /*Slogan*/
    //    oxOrientationLayOutPortrait.oxLayoutSloganLeft = @(70);
    oxOrientationLayOutPortrait.oxLayoutSloganTop = @(ratio*150+10);
    //    oxOrientationLayOutPortrait.oxLayoutSloganRight = @(70);
    //    oxOrientationLayOutPortrait.oxLayoutSloganBottom = @(70);
    oxOrientationLayOutPortrait.oxLayoutSloganWidth = @(300);
    oxOrientationLayOutPortrait.oxLayoutSloganHeight = @(20);
    oxOrientationLayOutPortrait.oxLayoutSloganCenterX = @(0);
    //    oxOrientationLayOutPortrait.oxLayoutSloganCenterY = @(0);
    
    /*登录按钮*/
    //    oxOrientationLayOutPortrait.oxLayoutLoginBtnLeft = @(70);
    oxOrientationLayOutPortrait.oxLayoutLoginBtnTop = @(ratio*180+10);
    //    oxOrientationLayOutPortrait.oxLayoutLoginBtnRight = @(70);
    //    oxOrientationLayOutPortrait.oxLayoutLoginBtnBottom = @(70);
    oxOrientationLayOutPortrait.oxLayoutLoginBtnWidth = @(ratio*310);
    oxOrientationLayOutPortrait.oxLayoutLoginBtnHeight = @(45);
    oxOrientationLayOutPortrait.oxLayoutLoginBtnCenterX = @(0);
    //    oxOrientationLayOutPortrait.oxLayoutLoginBtnCenterY = @(0);
    

    
    /*隐私条款*/
    //    oxOrientationLayOutPortrait.oxLayoutAppTermsLeft = @(70);
        oxOrientationLayOutPortrait.oxLayoutAppTermsTop = @(ratio*190+10+45+5);
    //    oxOrientationLayOutPortrait.oxLayoutAppTermsRight = @(70);
//    oxOrientationLayOutPortrait.oxLayoutAppTermsBottom = @(0);
        oxOrientationLayOutPortrait.oxLayoutAppTermsWidth = @(ratio*280);
//        oxOrientationLayOutPortrait.oxLayoutAppTermsHeight = @(80);
    oxOrientationLayOutPortrait.oxLayoutAppTermsCenterX = @(0);
    //    oxOrientationLayOutPortrait.oxLayoutAppTermsCenterY = @(70);
   
    /*协议页（oxAppTermsPageWindow==YES 生效）*/
    oxOrientationLayOutPortrait.oxLayoutAppTermsPageWidth = @(300);
    oxOrientationLayOutPortrait.oxLayoutAppTermsPageHeight = @(400);
    oxOrientationLayOutPortrait.oxLayoutAppTermsPageCenterX = @(0);
    oxOrientationLayOutPortrait.oxLayoutAppTermsPageCenterY = @(0);
    return oxOrientationLayOutPortrait;
}
//横屏
-(OXOrientationLayOut *)setLayoutLandscape{
    CGFloat ratio;
    if (TEST_SCREEN_WIDTH>TEST_SCREENH_HEIGHT) {
        ratio = TEST_SCREENH_HEIGHT/375;
    }else{
        ratio = TEST_SCREEN_WIDTH/375;
    }
    OXOrientationLayOut *oxOrientationLayOutLandscape = [OXOrientationLayOut new];
    /**LOGO图片*/
//        oxOrientationLayOutLandscape.oxLayoutLogoLeft = @(90);
    oxOrientationLayOutLandscape.oxLayoutLogoTop = @(0);
    //    oxOrientationLayOutLandscape.oxLayoutLogoRight = @(70);
    //    oxOrientationLayOutLandscape.oxLayoutLogoBottom = @(70);
    oxOrientationLayOutLandscape.oxLayoutLogoWidth = @(60);
    oxOrientationLayOutLandscape.oxLayoutLogoHeight = @(60);
    oxOrientationLayOutLandscape.oxLayoutLogoCenterX = @(0);
    //    oxOrientationLayOutLandscape.oxLayoutLogoCenterY = @(70);
    /**手机号显示控件*/
//        oxOrientationLayOutLandscape.oxLayoutPhoneLeft = @(120);
    oxOrientationLayOutLandscape.oxLayoutPhoneTop = @(ratio*30);
    //    oxOrientationLayOutLandscape.oxLayoutPhoneRight = @(70);
    //    oxOrientationLayOutLandscape.oxLayoutPhoneBottom = @(70);
    oxOrientationLayOutLandscape.oxLayoutPhoneWidth = @(200);
    oxOrientationLayOutLandscape.oxLayoutPhoneHeight = @(40);
    oxOrientationLayOutLandscape.oxLayoutPhoneCenterX = @(0);
    //    oxOrientationLayOutLandscape.oxLayoutPhoneCenterY = @(70);

        /*Slogan*/
//    oxOrientationLayOutLandscape.oxLayoutSloganLeft = @(120);
    oxOrientationLayOutLandscape.oxLayoutSloganTop = @(ratio*30+40+5);
    //    oxOrientationLayOutLandscape.oxLayoutSloganRight = @(70);
    //    oxOrientationLayOutLandscape.oxLayoutSloganBottom = @(70);
    oxOrientationLayOutLandscape.oxLayoutSloganWidth = @(200);
    oxOrientationLayOutLandscape.oxLayoutSloganHeight = @(20);
    oxOrientationLayOutLandscape.oxLayoutSloganCenterX = @(0);
    //    oxOrientationLayOutLandscape.oxLayoutSloganCenterY = @(70);
    
    /*登录按钮*/
//        oxOrientationLayOutLandscape.oxLayoutLoginBtnLeft = @(80);
    oxOrientationLayOutLandscape.oxLayoutLoginBtnTop = @(ratio*30+40+20+5+5);
    //    oxOrientationLayOutLandscape.oxLayoutLoginBtnRight = @(70);
    //    oxOrientationLayOutLandscape.oxLayoutLoginBtnBottom = @(70);
    oxOrientationLayOutLandscape.oxLayoutLoginBtnWidth = @(300);
    oxOrientationLayOutLandscape.oxLayoutLoginBtnHeight = @(45);
    oxOrientationLayOutLandscape.oxLayoutLoginBtnCenterX = @(0);
    //    oxOrientationLayOutLandscape.oxLayoutLoginBtnCenterY = @(70);
    
    /*隐私条款*/
    //    oxOrientationLayOutLandscape.oxLayoutAppTermsLeft = @(70);
        oxOrientationLayOutLandscape.oxLayoutAppTermsTop = @(ratio*30+40+20+45+45+5+5+5+10);
    //    oxOrientationLayOutLandscape.oxLayoutAppTermsRight = @(70);
//    oxOrientationLayOutLandscape.oxLayoutAppTermsBottom = @(0);
        oxOrientationLayOutLandscape.oxLayoutAppTermsWidth = @(250);
//        oxOrientationLayOutLandscape.oxLayoutAppTermsHeight = @(50);
    oxOrientationLayOutLandscape.oxLayoutAppTermsCenterX = @(0);
    //    oxOrientationLayOutLandscape.oxLayoutAppTermsCenterY = @(70);
    /*协议页（oxAppTermsPageWindow==YES 生效）*/
    oxOrientationLayOutLandscape.oxLayoutAppTermsPageWidth = @(350);
    oxOrientationLayOutLandscape.oxLayoutAppTermsPageHeight = @(300);
    oxOrientationLayOutLandscape.oxLayoutAppTermsPageCenterX = @(0);
    oxOrientationLayOutLandscape.oxLayoutAppTermsPageCenterY = @(0);
    return oxOrientationLayOutLandscape;
}


#pragma mark - 弹框Model

-(OXOneKeyCustomModel *)windowModel{
    OXOneKeyCustomModel *model = [[OXOneKeyCustomModel alloc] init];
    model.toastView = ^(UIView * _Nonnull containerView) {
        [OXTestShowToastView showToastView:containerView WithMessage:@"你还没勾选协议呢"];
    };
    model.loadingView = ^(UIView * _Nonnull containerView) {
        UIImage *image = [YYImage imageNamed:@"loading.gif"];
        UIImageView *imageBackground = [[YYAnimatedImageView alloc] initWithImage:image];
        [containerView addSubview:imageBackground];
        imageBackground.frame = CGRectMake(0, 0, 80, 80);
        imageBackground.center = containerView.center;
        imageBackground.layer.cornerRadius = 40;
        imageBackground.layer.masksToBounds = YES;
    };
    model.webLoadingView = ^(UIView * _Nonnull containerView) {
        UIImage *image = [YYImage imageNamed:@"loading.gif"];
        UIImageView *imageBackground = [[YYAnimatedImageView alloc] initWithImage:image];
        imageBackground.frame = CGRectMake(0, 0, 80, 80);
        imageBackground.center = containerView.center;
        imageBackground.layer.cornerRadius = 40;
        imageBackground.layer.masksToBounds = YES;
        [containerView addSubview:imageBackground];
    };

//    model.oxAuthWindowModalTransitionStyle = @(UIModalTransitionStyleFlipHorizontal);
    model.manualDismiss = @(NO);
    model.oxNavigationBackBtnImage = [UIImage imageNamed:@"close"];
    model.oxAppTermsWebBackBtnImage = [UIImage imageNamed:@"close"];
    model.oxNavigationBackgroundoxear = @(YES);
    model.oxBackgroundImg = [UIImage imageNamed:@"bg"];
//    model.oxNavigationBarTintColor = [UIColor redColor];
    model.oxAuthTypeUseWindow = @(YES);
    model.oxShouldAutorotate = @(YES);
    model.oxAppTermsPunctuationMarks = @(YES);
    model.oxPhoneNumberColor = TEST_HEXCOLOR(0x2F4D9D);
    model.oxSloganTextColor = TEST_HEXCOLOR(0x2F4D9D);
    model.oxAppTermsColor = @[TEST_HEXCOLOR(0xD866A5),TEST_HEXCOLOR(0x2F4D9D)];
    model.oxAppTermsPageWindow = @(YES);
    model.oxTermsTemplate = [[NSAttributedString alloc]initWithString:@"登录即同意&&默认&&和《百度》、《网易》、《搜狐》并使用本机号码登录" attributes:@{NSFontAttributeName:[UIFont systemFontOfSize:12]}];
    NSAttributedString *str1 = [[NSAttributedString alloc]initWithString:@"《百度》" attributes:@{NSLinkAttributeName:@"https://www.baidu.com"}];
    NSAttributedString *str2 = [[NSAttributedString alloc]initWithString:@"《网易》" attributes:@{NSLinkAttributeName:@"https://www.163.com"}];
    NSAttributedString *str3 = [[NSAttributedString alloc]initWithString:@"《搜狐》" attributes:@{NSLinkAttributeName:@"http://www.sohu.com"}];
    model.oxTerms = @[str1,str2,str3];
    model.oxOrientationLayOutPortrait = [self setWindowLayoutPortrait];
    model.oxOrientationLayOutLandscape = [self setWindowLayoutLandscape];
    return model;
}


#pragma mark 弹框Layout
/**-------------------------------弹框样式------------------------------*/
//弹框竖屏
-(OXOrientationLayOut *)setWindowLayoutPortrait{
    CGFloat ratio;
    if (TEST_SCREEN_WIDTH>TEST_SCREENH_HEIGHT) {
        ratio = TEST_SCREENH_HEIGHT/375;
    }else{
        ratio = TEST_SCREEN_WIDTH/375;
    }
    OXOrientationLayOut *oxOrientationLayOutPortrait = [OXOrientationLayOut new];
    oxOrientationLayOutPortrait.oxAuthWindowOrientationWidth = @(ratio*330);
    oxOrientationLayOutPortrait.oxAuthWindowOrientationHeight = @(ratio*400);
    oxOrientationLayOutPortrait.oxAuthWindowOrientationCenter = [NSValue valueWithCGPoint:CGPointMake([UIScreen mainScreen].bounds.size.width/2, [UIScreen mainScreen].bounds.size.height/2)];
    /**LOGO图片*/
    oxOrientationLayOutPortrait.oxLayoutLogoTop = @(10);
    oxOrientationLayOutPortrait.oxLayoutLogoWidth = @(ratio*60);
    oxOrientationLayOutPortrait.oxLayoutLogoHeight = @(ratio*60);
    oxOrientationLayOutPortrait.oxLayoutLogoCenterX = @(0);
    /**手机号显示控件*/
    oxOrientationLayOutPortrait.oxLayoutPhoneTop = @(ratio*70);
    oxOrientationLayOutPortrait.oxLayoutPhoneWidth = @(ratio*200);
    oxOrientationLayOutPortrait.oxLayoutPhoneHeight = @(ratio*40);
    oxOrientationLayOutPortrait.oxLayoutPhoneCenterX = @(0);
    
    /*登录按钮*/
    oxOrientationLayOutPortrait.oxLayoutLoginBtnTop = @(ratio*120);
    oxOrientationLayOutPortrait.oxLayoutLoginBtnWidth = @(ratio*280);
    oxOrientationLayOutPortrait.oxLayoutLoginBtnHeight = @(ratio*40);
    oxOrientationLayOutPortrait.oxLayoutLoginBtnCenterX = @(0);
    
    /*Slogan*/
    oxOrientationLayOutPortrait.oxLayoutSloganTop = @(ratio*160);
    oxOrientationLayOutPortrait.oxLayoutSloganWidth = @(ratio*300);
    oxOrientationLayOutPortrait.oxLayoutSloganHeight = @(ratio*40);
    oxOrientationLayOutPortrait.oxLayoutSloganCenterX = @(0);
    /*隐私条款*/
    oxOrientationLayOutPortrait.oxLayoutAppTermsBottom = @(-10);
    oxOrientationLayOutPortrait.oxLayoutAppTermsCenterX = @(0);
    oxOrientationLayOutPortrait.oxLayoutAppTermsWidth = @(ratio*280);
//    oxOrientationLayOutPortrait.oxLayoutAppTermsHeight = @(50);
    /*协议页（oxAppTermsPageWindow==YES 生效）*/
    oxOrientationLayOutPortrait.oxLayoutAppTermsPageWidth = @(300);
    oxOrientationLayOutPortrait.oxLayoutAppTermsPageHeight = @(400);
    oxOrientationLayOutPortrait.oxLayoutAppTermsPageCenterX = @(0);
    oxOrientationLayOutPortrait.oxLayoutAppTermsPageCenterY = @(0);
    return oxOrientationLayOutPortrait;
}
//弹框横屏
-(OXOrientationLayOut *)setWindowLayoutLandscape{
    CGFloat ratio;
    if (TEST_SCREEN_WIDTH>TEST_SCREENH_HEIGHT) {
        ratio = TEST_SCREENH_HEIGHT/375;
    }else{
        ratio = TEST_SCREEN_WIDTH/375;
    }
    OXOrientationLayOut *oxOrientationLayOutLandscape = [OXOrientationLayOut new];
    oxOrientationLayOutLandscape.oxAuthWindowOrientationWidth = @(ratio*400);
    oxOrientationLayOutLandscape.oxAuthWindowOrientationHeight = @(ratio*250);
    oxOrientationLayOutLandscape.oxAuthWindowOrientationCenter = [NSValue valueWithCGPoint:CGPointMake([UIScreen mainScreen].bounds.size.width/2, [UIScreen mainScreen].bounds.size.height/2)];
    /**LOGO图片*/
        oxOrientationLayOutLandscape.oxLayoutLogoLeft = @(ratio*90);
    oxOrientationLayOutLandscape.oxLayoutLogoTop = @(0);
    oxOrientationLayOutLandscape.oxLayoutLogoWidth = @(ratio*60);
    oxOrientationLayOutLandscape.oxLayoutLogoHeight = @(ratio*60);
    /**手机号显示控件*/
        oxOrientationLayOutLandscape.oxLayoutPhoneLeft = @(ratio*120);
    oxOrientationLayOutLandscape.oxLayoutPhoneTop = @(0);
    oxOrientationLayOutLandscape.oxLayoutPhoneWidth = @(ratio*200);
    oxOrientationLayOutLandscape.oxLayoutPhoneHeight = @(ratio*40);
    /*登录按钮*/
    oxOrientationLayOutLandscape.oxLayoutLoginBtnTop = @(ratio*85);
    oxOrientationLayOutLandscape.oxLayoutLoginBtnWidth = @(ratio*300);
    oxOrientationLayOutLandscape.oxLayoutLoginBtnHeight = @(ratio*40);
    oxOrientationLayOutLandscape.oxLayoutLoginBtnCenterX = @(0);
    /*Slogan*/
    oxOrientationLayOutLandscape.oxLayoutSloganLeft = @(ratio*120);
    oxOrientationLayOutLandscape.oxLayoutSloganTop = @(ratio*30);
    oxOrientationLayOutLandscape.oxLayoutSloganWidth = @(ratio*200);
    oxOrientationLayOutLandscape.oxLayoutSloganHeight = @(ratio*40);
    /*隐私条款*/
    oxOrientationLayOutLandscape.oxLayoutAppTermsBottom = @(-5);
    oxOrientationLayOutLandscape.oxLayoutAppTermsWidth = @(ratio*300);
//    oxOrientationLayOutLandscape.oxLayoutAppTermsHeight = @(50);
    oxOrientationLayOutLandscape.oxLayoutAppTermsCenterX = @(0);
    
    /*协议页（oxAppTermsPageWindow==YES 生效）*/
    oxOrientationLayOutLandscape.oxLayoutAppTermsPageWidth = @(350);
    oxOrientationLayOutLandscape.oxLayoutAppTermsPageHeight = @(300);
    oxOrientationLayOutLandscape.oxLayoutAppTermsPageCenterX = @(0);
    oxOrientationLayOutLandscape.oxLayoutAppTermsPageCenterY = @(0);
    return oxOrientationLayOutLandscape;
}

#pragma mark - 底部弹框Model

-(OXOneKeyCustomModel *)windowBottomUiModel{
    OXOneKeyCustomModel *model = [[OXOneKeyCustomModel alloc] init];
    model.webLoadingView = ^(UIView * _Nonnull containerView) {
        UIImage *image = [YYImage imageNamed:@"loading.gif"];
        UIImageView *imageBackground = [[YYAnimatedImageView alloc] initWithImage:image];
        [containerView addSubview:imageBackground];
        imageBackground.frame = CGRectMake(0, 0, 80, 80);
        imageBackground.center = containerView.center;
        imageBackground.layer.cornerRadius = 40;
        imageBackground.layer.masksToBounds = YES;
    };
    model.manualDismiss = @(NO);
    model.oxNavigationBackgroundoxear = @(YES);
    model.oxBackgroundImg = [UIImage imageNamed:@"bg"];
//    model.oxNavigationBarTintColor = [UIColor redColor];
    model.oxAuthTypeUseWindow = @(YES);
    model.oxAppTermsPageWindow = @(YES);
    model.oxAppTermsPageWindowCloseHeight = @(45);
    model.oxAppTermsPageWindowCloseText = [[NSAttributedString alloc]initWithString:@"关闭" attributes:@{NSForegroundColorAttributeName:[UIColor whiteColor]}];
//    model.oxAppTermsPageWindowCloseUIColor = [UIColor redColor];
    model.oxShouldAutorotate = @(WindowBottomModelShouldAutorotate);
    model.oxAppTermsPunctuationMarks = @(YES);
    model.oxPhoneNumberColor = TEST_HEXCOLOR(0x2F4D9D);
    model.oxSloganTextColor = TEST_HEXCOLOR(0x2F4D9D);
    model.oxAppTermsColor = @[TEST_HEXCOLOR(0xD866A5),TEST_HEXCOLOR(0x2F4D9D)];
    model.oxAuthWindowCornerRadius = @(0);
//    model.oxCheckBoxValue= @(YES);
    model.oxTermsTemplate = [[NSAttributedString alloc]initWithString:@"登录即同意&&默认&&和《百度》、《网易》、《搜狐》并使用本机号码登录" attributes:@{NSFontAttributeName:[UIFont systemFontOfSize:12]}];
    NSAttributedString *str1 = [[NSAttributedString alloc]initWithString:@"《百度》" attributes:@{NSLinkAttributeName:@"https://www.baidu.com"}];
    NSAttributedString *str2 = [[NSAttributedString alloc]initWithString:@"《网易》" attributes:@{NSLinkAttributeName:@"https://www.163.com"}];
    NSAttributedString *str3 = [[NSAttributedString alloc]initWithString:@"《搜狐》" attributes:@{NSLinkAttributeName:@"http://www.sohu.com"}];
    model.oxTerms = @[str1,str2,str3];
    model.oxOrientationLayOutPortrait = [self setWindowBottomLayoutPortrait];
    return model;
}


#pragma mark - 底部弹框Layout
/**-------------------------------弹框样式------------------------------*/
//弹框竖屏
-(OXOrientationLayOut *)setWindowBottomLayoutPortrait{
    CGFloat ratio;
    CGFloat screen_width;
    CGFloat screen_height;
    if (TEST_SCREEN_WIDTH>TEST_SCREENH_HEIGHT) {
        ratio = TEST_SCREENH_HEIGHT/375;
        screen_width = TEST_SCREENH_HEIGHT;
        screen_height = TEST_SCREEN_WIDTH;
    }else{
        ratio = TEST_SCREEN_WIDTH/375;
        screen_width = TEST_SCREEN_WIDTH;
        screen_height = TEST_SCREENH_HEIGHT;
    }
    CGFloat windowHeight = 220;
    OXOrientationLayOut *oxOrientationLayOutPortrait = [OXOrientationLayOut new];
    oxOrientationLayOutPortrait.oxAuthWindowOrientationWidth = @(screen_width);
    oxOrientationLayOutPortrait.oxAuthWindowOrientationHeight = @(windowHeight);
    oxOrientationLayOutPortrait.oxAuthWindowOrientationCenter = [NSValue valueWithCGPoint:CGPointMake(screen_width/2, screen_height-windowHeight/2)];
    /**LOGO图片*/
    oxOrientationLayOutPortrait.oxLayoutLogoLeft = @(90);
    oxOrientationLayOutPortrait.oxLayoutLogoTop = @(0);
    oxOrientationLayOutPortrait.oxLayoutLogoWidth = @(60);
    oxOrientationLayOutPortrait.oxLayoutLogoHeight = @(60);
    /**手机号显示控件*/
    oxOrientationLayOutPortrait.oxLayoutPhoneLeft = @(120);
    oxOrientationLayOutPortrait.oxLayoutPhoneTop = @(0);
    oxOrientationLayOutPortrait.oxLayoutPhoneWidth = @(200);
    oxOrientationLayOutPortrait.oxLayoutPhoneHeight = @(40);
    /*登录按钮*/
    oxOrientationLayOutPortrait.oxLayoutLoginBtnTop = @(75);
    oxOrientationLayOutPortrait.oxLayoutLoginBtnWidth = @(300);
    oxOrientationLayOutPortrait.oxLayoutLoginBtnHeight = @(40);
    oxOrientationLayOutPortrait.oxLayoutLoginBtnCenterX = @(0);
    /*Slogan*/
    oxOrientationLayOutPortrait.oxLayoutSloganLeft = @(120);
    oxOrientationLayOutPortrait.oxLayoutSloganTop = @(30);
    oxOrientationLayOutPortrait.oxLayoutSloganWidth = @(200);
    oxOrientationLayOutPortrait.oxLayoutSloganHeight = @(40);
    /*隐私条款*/
    oxOrientationLayOutPortrait.oxLayoutAppTermsBottom = @(-5);
    oxOrientationLayOutPortrait.oxLayoutAppTermsWidth = @(300);
    oxOrientationLayOutPortrait.oxLayoutAppTermsHeight = @(50);
    oxOrientationLayOutPortrait.oxLayoutAppTermsCenterX = @(0);
    /*弹框协议页*/
    oxOrientationLayOutPortrait.oxLayoutAppTermsPageWidth = @(300);
    oxOrientationLayOutPortrait.oxLayoutAppTermsPageHeight = @(400);
    oxOrientationLayOutPortrait.oxLayoutAppTermsPageCenterX = @(0);
    oxOrientationLayOutPortrait.oxLayoutAppTermsPageCenterY = @(0);
    return oxOrientationLayOutPortrait;
}
-(void)threeLoginClick{
//    [[OXHUD sharedHUD]showMessage:@"其它方式登录"];
                
    [OXClientEntry dismissLoginPageAnimated:NO completion:^{
        
    }];
    
    [self removeWindowMask];
}
-(void)helpBtnClick{
//    [[OXHUD sharedHUD]showMessage:@"获取帮助"];
}
//添加弹窗背景蒙版
-(void)showWindowMask{
//    UIView * windowMask = [self.view viewWithTag:2019];
//    if (windowMask == nil) {
//        windowMask = [[UIView alloc]initWithFrame:self.view.bounds];
//        windowMask.backgroundColor = [[UIColor blackColor] colorWithAlphaComponent:0.4];
//        windowMask.tag = 2019;
//    }
//    [self.view addSubview:windowMask];
//    [windowMask mas_makeConstraints:^(MASConstraintMaker *make) {
//        make.edges.insets(UIEdgeInsetsZero);
//    }];
}
//移除弹窗背景蒙版
-(void)removeWindowMask{
//    dispatch_async(dispatch_get_main_queue(), ^{
//        UIView * windowMask = [self.view viewWithTag:2019];
//        [windowMask removeFromSuperview];
//    });
}
/// 初始化秒验SDK
/// @param appid 应用id
/// @param appsecret 应用secret
- (void)initSAIWithAppid:(NSString *)appid appserect:(NSString *)appsecret{
    if(appid ==nil||appsecret==nil||appid.length==0||appsecret.length==0){
        NSLog(@"appid or appsecret is nil");
    }
    //官网创建应用获得appId appSecret
    //建议服务端下发不要写死
    NSString *appId = appid;
    NSString *appSecret = appsecret;
    //注意填写完appId和appSecret后，去修改当前项目的包名，否则会导致初始化失败
    NSMutableDictionary *params = [[NSMutableDictionary alloc] init];
    params[OXAppid] = appId;
    params[OXAppSecret] = appSecret;
    [OXClientEntry printConsoleEnable:YES];
//    [OXClientEntry printConsoleEnable:YES];
    [OXClientEntry initWithParams:params delegate:self];
}
- (UIViewController *)appRootViewController
{

    UIViewController *RootVC = [UIApplication sharedApplication].keyWindow.rootViewController;

    UIViewController *topVC = RootVC;

    while (topVC.presentedViewController) {
        
        topVC = topVC.presentedViewController;
        
    }

    return topVC;
}
@end
