//
//  OXTestShowToastView.m
//  OXExample
//
//  Created by OX on 2019/11/12.
//  Copyright © 2019年 OX. All rights reserved.
//

#import "OXTestShowToastView.h"

@implementation OXTestShowToastView
//Toast提示框
+(void)showToastView:(UIView *)uiview WithMessage:(NSString *)message
{
    UIView *showview = [[UIView alloc]init];
    showview.backgroundColor = [UIColor colorWithRed:0 green:0 blue:0 alpha:.3];
    showview.frame = CGRectMake(1, 1, 1, 1);
    showview.layer.cornerRadius = 5.0f;
    showview.layer.masksToBounds = YES;
    [uiview addSubview:showview];
    UILabel *label = [[UILabel alloc]init];
    NSDictionary *attribute = @{NSFontAttributeName: [UIFont systemFontOfSize:17]};
    CGSize LabelSize = [message boundingRectWithSize:CGSizeMake(290, 9000)
                                             options:NSStringDrawingTruncatesLastVisibleLine|NSStringDrawingUsesLineFragmentOrigin|NSStringDrawingUsesFontLeading
                                          attributes:attribute context:nil].size;
    label.frame = CGRectMake(10, 5, LabelSize.width, LabelSize.height);
    label.text = message;
    label.textColor = [UIColor whiteColor];
    label.textAlignment = 1;
    label.backgroundColor = [UIColor clearColor];
    label.font = [UIFont boldSystemFontOfSize:15];
    [showview addSubview:label];
    showview.frame = CGRectMake((uiview.frame.size.width - LabelSize.width - 20)/2, uiview.frame.size.height - LabelSize.height-100, LabelSize.width+20, LabelSize.height+10);
    [UIView animateWithDuration:1.5 animations:^{
        showview.alpha = 0;
    } completion:^(BOOL finished) {
        [showview removeFromSuperview];
    }];
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
