import 'dart:async';

import 'package:flutter/services.dart';

class OxSaiFlutterSdk {
  static const MethodChannel _channel =
      const MethodChannel('ox_sai_flutter_sdk');
  //获取版本号
  static Future<String> get sdkVersion async {
    final String version = await _channel.invokeMethod('getSdkVersion');
    return version;
  }
  //初始化SDK
  static Future<Map> oxInitSaiSDK(String appid,String appsecret) async {
    Map<String, dynamic> map = {"appid": appid, "appsecret":appsecret};
    Map response = await _channel.invokeMethod('oxInitSaiSDK',map);
    return response;
  }
  //一键登录
  static Future<Map> oxOnekeyLogin() async {
    Map response = await _channel.invokeMethod('oxOnekeyLogin');
    return response;
  }
  //本机号码校验
  static Future<Map> oxAuthMobilePhone() async {
    Map response = await _channel.invokeMethod('oxAuthMobilePhone');
    return response;
  }
  //预取号
  static Future<Map> oxPreLogin() async {
    Map response = await _channel.invokeMethod('oxPreLogin');
    return response;
  }


}
